---
title: RegExp.input ($_)
slug: Web/JavaScript/Reference/Global_Objects/RegExp/input
tags:
  - JavaScript
  - Non-standard
  - Property
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}} {{non-standard_header}}</div>

<p>The non-standard <strong><code>input</code> </strong>property is a static property of regular expressions that contains the string against which a regular expression is matched. <code>RegExp.$_</code> is an alias for this property.</p>

<h2 id="Description">Description</h2>

<p>The <code>input</code> property is static, it is not a property of an individual regular expression object. Instead, you always use it as <code>RegExp.input</code> or <code>RegExp.$_.</code></p>

<p>The value of the <code><strong>input</strong></code> property is modified whenever the searched string on the regular expression is changed and that string is matching.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_input_and__">Using <code>input</code> and <code>$_</code></h3>

<pre class="brush: js">var re = /hi/g;
re.test('hi there!');
RegExp.input;         // "hi there!"
re.test('foo');       // new test, non-matching
RegExp.$_;            // "hi there!"
re.test('hi world!'); // new test, matching
RegExp.$_;            // "hi world!"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Legacy RegExp features')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.input")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RegExp.lastMatch", "RegExp.lastMatch ($&amp;)")}}</li>
 <li>{{jsxref("RegExp.lastParen", "RegExp.lastParen ($+)")}}</li>
 <li>{{jsxref("RegExp.leftContext", "RegExp.leftContext ($`)")}}</li>
 <li>{{jsxref("RegExp.rightContext", "RegExp.rightContext ($')")}}</li>
 <li>{{jsxref("RegExp.n", "RegExp.$1-$9")}}</li>
</ul>
